/**
*	AVRŊȈNTPT[o
*	Copyright (c)Junnichi Tomaru 2008
*/
#include	<string.h>
#include	<ctype.h>
#include	<avr/io.h>
#include	<avr/wdt.h>
#include	<avr/interrupt.h>
#include	<avr/pgmspace.h>
#include	<avr/eeprom.h>
#include	"enc28j60.h"
#include	"lcd.h"
#include	"stime.h"
#include	"ethernet.h"
#include	"arp.h"
#include	"ip.h"
#include	"icmp.h"
#include	"udp.h"
#include	"protocol.h"
#include	"ut.h"
#include	"userdef.h"
#include	"prottype.h"
#include	"define.h"

#define	VERSION	"0.18.00"	/* \tgEFAo[W */

/* ENC28J60MXe[^Xi[p */
struct RX_STATUS{
	ui_t	next;
	ui_t	rxcount;
	byte	longevent : 1;
	byte	reserved1 : 1;
	byte	carrierpreviouslyseen : 1;
	byte	reserved2 : 1;
	byte	crcerror : 1;
	byte	lengthcheckerr : 1;
	byte	lengthoutofrange : 1;
	byte	receiveok : 1;
	byte	multicast : 1;
	byte	broadcast : 1;
	byte	dribblenibble : 1;
	byte	ctrlframe : 1;
	byte	pausecontrolframe : 1;
	byte	unknownopcode : 1;
	byte	vlantype : 1;
	byte	zero : 1;
};
typedef struct RX_STATUS rxstatus_t;

/* ENC28J60MXe[^Xi[p */
struct TX_STATUS{
	ui_t	bytecount;
	byte	colcnt : 4;
	byte	crcerror : 1;
	byte	lenchkerr : 1;
	byte	lenuor : 1;
	byte	txdone : 1;
	byte	multicast : 1;
	byte	broadcast : 1;
	byte	pctdefer : 1;
	byte	excdefer : 1;
	byte	exccol : 1;
	byte	latecol : 1;
	byte	giant : 1;
	byte	underrun : 1;
	ui_t	txonwire;
	byte	ctrlframe : 1;
	byte	pausectrlframe : 1;
	byte	bakprsapli : 1;
	byte	vlantag : 1;
	byte	zero : 4;
};
typedef struct TX_STATUS txstatus_t;

/* ARPLbVe[u */
struct ARP_TB{
	dword	ipaddr;		/* IPAhX */
	byte	mac[6];		/* MACAhX */
	byte	timer;		/* ARP^C}1024msP,Z^Cv */
};
typedef struct ARP_TB	arp_tb;

/* pPbgp\ */
struct	ETHER_T{
	word	datasize;	/* f[^ */
	byte	mac[6];		/* MACAhX */
	dword	partipaddr;	/* IPAhX */
	dword	myipaddr;
	word	partport;
	word	myport;
	word	proto_body;
	word	proto_len;
	dword	seq;		/*  */
};
typedef struct	ETHER_T	ether_t;

_Extern byte	mac_address[6];	/* MACAhX */
_Extern dword	myipaddr;	/* IPAhX */
_Extern dword	netmask;	/* Tulbg}XN */
_Extern dword	gateway;	/* ftHgQ[gEFC */
_Extern pseudo_st	pseudo_hdr;	/* [wb_ */
_Extern ether_t	pacinfo;	/* pPbg */

_Extern arp_tb	arp_cache;	/* ARPLbVe[u */
_Extern byte	ip_hdrlen;	/* IPwb_ */
_Extern word	ip_identifer;	/* IPID */
_Extern char	nbns_name[16];	/* NetBIOS */
_Extern swbool	lcden;		/* t */
_Extern word	interval;	/* `FbNԊuCfbNX */

/* ENC28J60 */
_Extern rxstatus_t	rxstatus;
_Extern word	nowrxpnt;	/* ݂̎MpPbg擪 */
_Extern word	nextrxpnt;	/* ̎MpPbg擪 */

/* Ԋ֌W */
_Extern time_t	time;		/* (1970/1/1̕b) */
_Extern char	timeen;		/* Ă邩 */
_Extern swbool	adjust;		/* ␳ */
_Extern struct tm	jst_time;	/* { */
_Extern struct tm	utc_time;	/* UTC */
_Extern struct tm	old_time;	/* oߎԌvp */
_Extern time_t	rxstamp;	/* pPbgM(b) */
_Extern word	rxtime;		/* 1msƃpPbgMJEgl */
_Extern time_t	rnstamp;	/* XV(b) */
_Extern word	rntime;		/* 1msƍXVJEgl */
_Extern char	cal_mon;
_Extern char	cal_day;
_Extern char	cal_hour;
_Extern char	cal_min;
_Extern char	cal_sec;

/* 荞ݓŕύXϐ */
volatile word	timer;		/* PbvpJE^ */
volatile swbool	timeflg;	/* XV */
volatile char	keybuf[4];	/* L[ */
volatile byte	keypnt;

/* end of avrntp.h */
