/**
*	ENC28J60hCo
*	ATmega168 SPI@\gp(MODE 0,0)
*	EREVID=04H,05Hł̐
*	  ERXWRPTERXSTŕςȂH(Mobt@0000Hzu)
*	Copyright (c)Junnichi Tomaru 2006-2008
*/
#include	"avrntp.h"

#define	CS_ASSERT()	asm("cbi 0x05, 2"::)
#define	CS_NEGATE()	asm("sbi 0x05, 2"::)

#define	WAIT_MIBUSY()	while(enc_readmreg(MISTAT)&MISTAT_BUSY)
#define	WAIT_DMAEND()	while(enc_readethreg(ECON1)&ECON1_DMAST)

#define	BUFFERSTART	0x0000
#define	BUFFEREND	0x1fff
#define MAX_FRAME	1518


/**
*	SPIŃf[^𑗐M(8bit)
*	 in	f[^
*	out	Ȃ
*/
void	spitx( char data )
{
	SPDR = data;		 /* f[^M */
	loop_until_bit_is_set( SPSR, SPIF );	 /* ]܂őҋ@*/
}


/**
*	VXeZbg(ENC28J60̃\tgEFAZbg)
*	 in	Ȃ
*	out	Ȃ
*/
static void	enc_systemreset( void )
{
	CS_ASSERT( );
	spitx( ENC_SC );
	CS_NEGATE( );
}


/**
*	Rg[WX^ǂ(ETHO[v)
*	 in	WX^AhX
*	out	f[^
*/
byte	enc_readethreg( char addr )
{
	byte	ret;

	CS_ASSERT( );
	spitx( ENC_RCR + addr );/* OPCODE + ADDR */
	spitx( 0 );		/* Mp_~[M */
	ret = SPDR;		/* Mf[^ */
	CS_NEGATE( );

	return ret;
}


/**
*	MAC&MIIWX^ǂ
*	 in	WX^AhX
*	out	f[^
*/
byte	enc_readmreg( char addr )
{
	byte	ret;

	CS_ASSERT( );
	spitx( ENC_RCR + addr );/* OPCODE + ADDR */
	spitx( 0 );		/* Mp_~[M */
	ret = SPDR;		/* f[^ */
	spitx( 0 );		/* Mp_~[M */
	ret = SPDR;		/* Mf[^ */
	CS_NEGATE( );

	return ret;
}


/**
*	WX^Ƀf[^
*	 in	addr:WX^AhX
*		data:f[^(8bit)
*	out	Ȃ
*/
void	enc_writereg( char addr, byte data )
{
	CS_ASSERT( );
	spitx( ENC_WCR + addr );/* OPCODE + ADDR */
	spitx( data );		/* f[^ */
	CS_NEGATE( );
}


/**
*	Rg[WX^ǂ(16rbg)
*	 in	AhX(Lower)
*	out	WX^̒l
*/
static word	enc_readethreg16( char addr )
{
	ui_t	t;

	t.bytes.lo = enc_readethreg( addr );	/* LOWER BYTE */
	t.bytes.hi = enc_readethreg( addr + 1 );/* HIGHER BYTE */

	return	t.data;
}


/**
*	MAC&MIIWX^ǂ(16rbg)
*	 in	AhX(Lower)
*	out	WX^̒l
*/
/*word	enc_readmreg16( char addr )*/
/*{*/
/*	ui_t	t;*/

/*	t.bytes.lo = enc_readmreg( addr );*/	/* LOWER BYTE */
/*	t.bytes.hi = enc_readmreg( addr + 1 );*/	/* HIGHER BYTE */

/*	return	t.data;*/
/*}*/


/**
*	WX^(16rbg)
*	 in	addr:AhX(L)
*		data:WX^̒l
*	out	Ȃ
*/
void	enc_writereg16( char addr, word data )
{
	ui_t	t;

	t.data = data;
	enc_writereg( addr, t.bytes.lo );	/* LOWER BYTE */
	enc_writereg( addr + 1, t.bytes.hi );	/* HIGHER BYTE */
}


/**
*	rbgtB[hZbg(ETHWX^̂,rbgOR)
*	 in	addr:WX^AhX
*		data:1̃rbgZbg
*	out	Ȃ
*/
void	enc_setbit( char addr, byte data )
{
	CS_ASSERT( );
	spitx( ENC_BFS + addr );/* OPCODE + ADDR */
	spitx( data );		/* f[^ */
	CS_NEGATE( );
}


/**
*	rbgtB[hNA(ETHWX^̂,rbgNot-AND)
*	 in	addr:WX^AhX
*		data:1̃rbgNA
*	out	Ȃ
*/
void	enc_clrbit( char addr, byte data )
{
	CS_ASSERT( );
	spitx( ENC_BFC + addr );/* OPCODE + ADDR */
	spitx( data );		/* f[^ */
	CS_NEGATE( );
}


/**
*	oNZNg
*	̃rbgȂ悤ɁArbgtB[h߂gp
*	 in	oNԍ
*	out	Ȃ
*/
void	enc_bankselect( byte bank )
{
	enc_clrbit( ECON1, 0x3 );	/* BSEL0,BSEL1NA */
	enc_setbit( ECON1, bank & 0x3 );/* oNԍZbg */
}


/**
*	PHYWX^ǂ
*	 in	ǂݍރAhX
*	out	16rbgf[^
*/
/*word	enc_readphy( byte addr )*/
/*{*/
/*	enc_bankselect( 2 );*/
/*	enc_writereg( MIREGADR, addr );*/	/* AhXw */
/*	enc_writereg( MICMD, MICMD_MIIRD );*/	/* MIRDPxǂ */

/*	enc_bankselect( 3 );*/
/*	WAIT_MIBUSY( );*/		/* PHYWX^ǂݍ܂̂҂ */

/*	enc_bankselect( 2 );*/
/*	enc_writereg( MICMD, 0x00 );*/	/* ǂݍݒ~(MIIRD=0) */

/*	return	enc_readmreg16( MIRD );*/	/* f[^ǂݏo */
/*}*/


/**
*	PHYWX^ɏ
*	 in	addr:WX^AhX
*		data:ރf[^
*	out	Ȃ
*/
void	enc_writephy( byte addr, word data )
{
	enc_bankselect( 2 );
	enc_writereg( MIREGADR, addr );	/* WX^AhX */

	enc_writereg16( MIWR, data );	/* f[^ */

	enc_bankselect( 3 );
	WAIT_MIBUSY( );		/* I҂ */
}


/**
*	C[Tlbgobt@PoCgǂݍ
*	 in	Ȃ
*	out	ǂݍ񂾃f[^
*/
byte	enc_readbuf( void )
{
	byte	ret;

	CS_ASSERT( );
	spitx( ENC_RBM );	/* obt@ǂݍ */
	spitx( 0 );	/* Mp_~[M */
	ret = SPDR;
	CS_NEGATE( );

	return ret;
}


/**
*	C[Tlbgobt@QoCgǂݍ
*	 in	Ȃ
*	out	ǂݍ񂾃f[^(gGfBA)
*/
word	enc_readbuf2( void )
{
	ui_t	t;

	CS_ASSERT( );
	spitx( ENC_RBM );	/* obt@ */
	spitx( 0 );		/* Mp_~[M */
	t.bytes.hi = SPDR;
	spitx( 0 );		/* Mp_~[M */
	t.bytes.lo = SPDR;
	CS_NEGATE( );

	return	t.data;
}


/**
*	C[Tlbgobt@SoCgǂݍ
*	 in	Ȃ
*	out	ǂݍ񂾃f[^(gGfBA)
*/
/*dword	enc_readbuf4( void )*/
/*{*/
/*	ul_t	t;*/

/*	CS_ASSERT( );*/
/*	spitx( ENC_RBM );*/	/* obt@ */
/*	spitx( 0 );*/		/* Mp_~[M */
/*	t.bytes.hh = SPDR;*/
/*	spitx( 0 );*/		/* Mp_~[M */
/*	t.bytes.hl = SPDR;*/
/*	spitx( 0 );*/		/* Mp_~[M */
/*	t.bytes.lh = SPDR;*/
/*	spitx( 0 );*/		/* Mp_~[M */
/*	t.bytes.ll = SPDR;*/
/*	CS_NEGATE( );*/

/*	return	t.data;*/
/*}*/


/**
*	C[Tlbgobt@Aǂݍ
*	 in	buffer:f[^i[obt@
*		   len:ǂݍރoCg
*	out	Ȃ
*/
void	enc_readbuffer( byte *buffer, word len )
{
	word	i;

	CS_ASSERT( );
	spitx( ENC_RBM );	/* obt@ǂݍ */
	for( i = 0; i < len; i++, buffer++ ){
		spitx( 0 );	/* Mp_~[M */
		*buffer = SPDR;
	};
	CS_NEGATE( );
}


/**
*	C[Tlbgobt@ɂPoCg
*	EWRPTAhX珑܂܂
*	 in	f[^
*	out	Ȃ
*/
void	enc_writebuf( byte data )
{
	CS_ASSERT( );
	spitx( ENC_WBM );	/* obt@ */
	spitx( data );
	CS_NEGATE( );
}


/**
*	obt@ɂQoCg
*	EWRPTAhX珑܂܂
*	 in	ޒl
*	out	Ȃ
*/
void	enc_writebuf2( word data )
{
	ui_t	t;

	t.data = data;
	CS_ASSERT( );
	spitx( ENC_WBM );	/* obt@ */
	spitx( t.bytes.hi );
	spitx( t.bytes.lo );
	CS_NEGATE( );
}


/**
*	obt@ɂRoCg
*	EWRPTAhX珑܂܂
*	 in	ޒl
*	out	Ȃ
*/
/*void	enc_writebuf3( dword data )*/
/*{*/
/*	ul_t	t;*/

/*	t.data = data;*/
/*	CS_ASSERT( );*/
/*	spitx( ENC_WBM );*/	/* obt@ */
/*	spitx( t.bytes.hl );*/
/*	spitx( t.bytes.lh );*/
/*	spitx( t.bytes.ll );*/
/*	CS_NEGATE( );*/
/*}*/


/**
*	obt@ɂSoCg
*	EWRPTAhX珑܂܂
*	 in	ޒl
*	out	Ȃ
*/
void	enc_writebuf4( dword data )
{
	ul_t	t;

	t.data = data;
	CS_ASSERT( );
	spitx( ENC_WBM );	/* obt@ */
	spitx( t.bytes.hh );
	spitx( t.bytes.hl );
	spitx( t.bytes.lh );
	spitx( t.bytes.ll );
	CS_NEGATE( );
}


/**
*	obt@Ƀo[Xg
*	EWRPTAhX珑܂܂
*	 in	buffer:݃obt@̃|C^
*		   len:ރoCg
*	out	Ȃ
*/
void	enc_writebuffer( byte *buffer, word len )
{
	word	i;

	CS_ASSERT( );
	spitx( ENC_WBM );	/* obt@ */
	for( i = 0; i < len; i++, buffer++ ){
		spitx( *buffer );
	}
	CS_NEGATE( );
}


/**
*	obt@ɓf[^𖄂߂
*	EWRPTAhX珑܂܂
*	 in	data:ރf[^
*		 len:ރoCg
*	out	Ȃ
*/
void	enc_fillwrite( byte data, word len )
{
	word	i;

	CS_ASSERT( );
	spitx( ENC_WBM );	/* obt@ */
	for( i = 0; i < len; i++ ){
		spitx( data );
	}
	CS_NEGATE( );
}


/**
*	Ȑff[`
*	 in	Ȃ
*	out	FALSE:ُ TRUE:
*/
static bool	enc_selftest( void )
{
	bool	ret;

	enc_writereg( ECON1, 0 );	/* y[WO */
	enc_writereg16( EDMAST, BUFFERSTART );	/* DMAJnAhX */
	enc_writereg16( EDMAND, BUFFEREND );	/* DMAIAhX */
	enc_writereg16( ERXND, BUFFEREND );	/* MIAhX */

	enc_bankselect( 3 );
	enc_writereg( EBSTCON, ADR_FIL | EBSTCON_TME | EBSTCON_BISTST );
			/* AhXtB,rbgeXg[h */

	/* DMAJnOBISTÎ҂AeXg[h֎~ */
	while( enc_readethreg( EBSTCON ) & EBSTCON_BISTST );
	enc_clrbit( EBSTCON, EBSTCON_TME );

	/* TvZADMAX^[g */
	enc_setbit( ECON1, ECON1_DMAST | ECON1_CSUMEN );
	WAIT_DMAEND( );

	enc_bankselect( 0 );
	/* `FbNTr */
	if( enc_readethreg16( EDMACS ) != 0xF807 ){	/* AhXtB̌ʂF807hɂȂ͂ */
		ret = FALSE;
	}
	else{
		ret = TRUE;
	}
	return	ret;
}


/**
*	ENC28J60
*	 in	Ȃ
*	out	Ȃ
*/
void	enc_init( void )
{
/*	byte	i;*/

	if( enc_selftest( ) == 0 ){	/* Ȑff */
		enc_writephy( PHLCON, PHLCON_LACFG3 | PHLCON_LACFG1
			 | PHLCON_LBCFG3 | PHLCON_LBCFG1 | PHLCON_STRCH );
		while( 1 );	/* _ȂƂ́A_ł */
	}

	enc_systemreset( );	/* ENC28J60 RESET */
/*	while( 1 ){*/		/* CLKRDY҂ */
/*		i = enc_readethreg( ESTAT );*/
/*		if((( i & 0x08 ) == 0 ) && ( i & ESTAT_CLKRDY )){*/
/*			break;*/
/*		}*/
/*	}*/
	waitms( 1 );	/* 1msȏ҂ĂΗǂ(ERRATAɂ) */

	enc_writereg( ECON1, ECON1_TXRST | ECON1_RXRST );/* TX,RX,Zbg,y[WO */
	enc_writereg( ECON2, ECON2_AUTOINC );	/* obt@|C^CNg */

	enc_writereg16( ERXST, RXSTART );	/* Mobt@JnAhX */
	enc_writereg16( ERXRDPT, RXSTART );	/* EAhX */
	enc_writereg16( ERXND, RXSTOP );	/* Mobt@IAhX */
	enc_writereg16( ETXST, TXSTART );	/* Mobt@JnAhX */

	enc_bankselect( 1 );
	enc_writereg( ERXFCON, 0xaa );		/* }`LXg͎MȂ */

	enc_bankselect( 2 );
	enc_writereg( MACON1, MACON1_MARXEN | MACON1_RXPAUS );
	enc_writereg( MACON2, 0x00 );		/* Zbg𔲂 */

	/* 60oCg܂ŃpfBO,CRCt */
	enc_setbit( MACON3, MACON3_PADCFG0 | MACON3_TXCRCEN | MACON3_FRMLNEN );
	enc_writereg16( MAMXFL, MAX_FRAME );	/* pPbg̍ől */

	enc_writereg16( MAIPG, 0x0C12 );	/* MAC BACK-TO-BACK INTER-PACKET GAP RESISTER */
	enc_writereg( MABBIPG, 0x12 );		/* lHALF=0x12 */

	/* MAC ADDRESSݒ */
	enc_bankselect( 3 );
	enc_writereg( MAADR5, mac_address[0] );
	enc_writereg( MAADR4, mac_address[1] );
	enc_writereg( MAADR3, mac_address[2] );
	enc_writereg( MAADR2, mac_address[3] );
	enc_writereg( MAADR1, mac_address[4] );
	enc_writereg( MAADR0, mac_address[5] );

	/* [vobN */
	enc_writephy( PHCON1, 0x0000 );		/* p[_E */
	enc_writephy( PHCON2, PHCON2_HDLDIS );
	/* LEDA:N LEDB:MXe[^X */
	enc_writephy( PHLCON, LEDA_LINK | LEDB_RXACT | PHLCON_STRCH );

	enc_bankselect( 0 );
#ifdef USE_INT
	enc_setbit( EIE, EIE_INTIE | EIE_PKTIE );	/* 荞݋ */
#endif
	enc_writereg( ECON1, ECON1_RXEN );	/* M */
}


/**
*	NԎ擾
*	 in	Ȃ
*	out	TRUE:N  FALSE:񃊃N
*/
/*bool	enc_getlinkstatus( void )*/
/*{*/
/*	return ( enc_readphy( PHSTAT1 ) & PHSTAT1_LLSTAT )? TRUE: FALSE;*/
/*}*/


/**
*	Mł邩𒲂ׂ
*	 in	Ȃ
*	out	TRUE:M\  FALSE:Ms\
*/
/*bool	enc_gettxready( void )*/
/*{*/
/*	return ( enc_readethreg( ECON1 ) & ECON1_TXRST )? FALSE: TRUE;*/
/*}*/


/**
*	Mobt@ǂݏoʒuݒ
*	 in	擪̃ItZbgl(Xe[^X܂܂)
*	out	Ȃ
*/
void	enc_rxseek( word offset )
{
	word	i;

	enc_bankselect( 0 );
	i = nowrxpnt + RXSTS_SIZE + offset;
	if( i > RXSTOP ){	/* ܂ԂĂ */
		i -= RXSIZE;
	}
	enc_writereg16( ERDPT, i );
}


/**
*	Mobt@݈ʒuݒ
*	 in	擪̃ItZbgl(PPCB܂܂)
*	out	Ȃ
*/
void	enc_txseek( word offset )
{
	enc_bankselect( 0 );
	enc_writereg16( EWRPT, offset + TXSTART + PPCB_SIZE );
}


/**
*	̃pPbgʒuֈړ
*	 in	Ȃ
*	out	Ȃ
*/
void	enc_setnextpoint( void )
{
	/* ǂݍ݈ʒuÃpPbg擪܂ňړ */
/*	nextrxpnt--;*/
/*	if( nextrxpnt > RXSTOP ){*/	/* for rev4,5(ǁAƂ) */
/*		nextrxpnt = RXSTOP;*/
/*	}*/
	/* MpPbgJE^fNg */
	enc_setbit( ECON2, ECON2_PKTDEC );

	enc_bankselect( 0 );
	enc_writereg16( ERXRDPT, nextrxpnt );

#ifdef USE_INT
	enc_setbit( EIE, EIE_INTIE );	/* 荞݋ */
#endif
}


/**
*	Mobt@̋󂫃TCY𒲂ׂ
*	 in	Ȃ
*	out	TCY
*/
/*word	enc_getfreerxsize( void )*/
/*{*/
/*	word	rp, wp;*/
/*	byte	c, d;*/
/*	word	ret;*/
/**/
	/* ܂ʒuǂފԂɍXVꂽǂ𒲂ׁA */
	/* ςĂǂݒ */
/*	enc_bankselect( 1 );*/
/*	c = enc_readethreg( EPKTCNT );*/	/* Pړǂݍ */
/*	while( 1 ){*/
/*		enc_bankselect( 0 );*/
/*		wp = enc_readethreg( ERXWRPT ) & 0x1fff;*/
/*		enc_bankselect( 1 );*/
/*		d = enc_readethreg( EPKTCNT );*/
/*		if( c == d ){*/	/* ςĂȂ */
/*			break;*/
/*		}*/
/*		c = d;*/
/*	}*/
	/* ݋EAhXǂ */
/*	rp = enc_readethreg16( ERXRDPT ) & 0x1fff;*/
/**/
/*	if( wp > rp ){*/		/* ERXWRPT̕傫 */
/*		ret = (( RXSTOP - RXSTART ) - ( wp - rp ));*/
/*	}*/
/*	else if( wp == rp ){*/	/* ꏊ */
/*		ret = ( RXSTOP - RXSTART );*/
/*	}*/
/*	else{*/			/* ERXRDPT̕傫 */
/*		ret = ( rp - wp - 1 );*/
/*	}*/
/**/
/*	return	ret;*/
/*}*/


/**
*	t[M
*	 in	ǂݍ݃obt@
*	out	1:M  0:MȂ
*/
byte	enc_input( byte *buf )
{
	enc_bankselect( 1 );
	if( enc_readethreg( EPKTCNT ) == 0 ){	/* MȂ */
		return 0;
	}

	/* ǂݍ݂̐擪ʒuɓǂݍ݃|C^Zbg */
	enc_bankselect( 0 );
	enc_writereg16( ERDPT, nextrxpnt );
	nowrxpnt = nextrxpnt;			/* ̈ʒuobNAbv */

	enc_readbuffer((byte *)&rxstatus, RXSTS_SIZE );	/* ̃|C^ƃXe[^Xǂݍ */
	rxstatus.next.bytes.hi &= 0x1f;		/* ʃrbg}XN(unimplemented) */
	rxstatus.rxcount.bytes.hi &= 0x1f;	/* ʃrbg}XN(unimplemented) */
	nextrxpnt = rxstatus.next.data;		/* ̃pPbg擪 */
	if(( rxstatus.next.data > RXSTOP ) || ( rxstatus.next.data & 0x1 )
	   || ( rxstatus.zero ) || ( rxstatus.crcerror )
	   || ( rxstatus.rxcount.data > MAX_FRAME )|| ( rxstatus.receiveok == 0 )){
						/* G[ */
		enc_init( );
		return	0;
	}
	else{				/* pPbg̎荞ݏ */
		_di( );
		rxstamp = time;
		rxtime = timer;
		_ei( );
		enc_readbuffer( buf, ETHERHDR_SIZE );	/* C[Tlbgwb_荞 */
	}

	return 1;
}


/**
*	t[M
*	 in	Ȃ
*	out	Ȃ
*/
void	enc_output( void )
{
	pacinfo.datasize += PPCB_SIZE;
	enc_writereg16( EWRPT, TXSTART );
	enc_writereg16( ETXND, pacinfo.datasize + TXSTART - 1 );
				/* Mt[Iʒu */
	enc_writebuf( 0x00 );	/* Format For Per Packet Control Bytes */
				/* MACON3̏Ԃgp */
	/* Erattaɂ */
	if( enc_readethreg( EIR ) & EIR_TXERIF ){
		enc_clrbit( EIR, EIR_TXERIF );
		enc_setbit( ECON1, ECON1_TXRST );
		enc_clrbit( ECON1, ECON1_TXRST );
	}
	enc_setbit( ECON1, ECON1_TXRTS );	/* M */
}


/**
*	M`FbNTvZ(ERRATAɂADMAgƃ_ȂƂ)
*	in	offset:C[Tlbgt[擪̃ItZbg
*		   len:`FbNTvZ͈͒
*	out	`FbNT
*/
word	enc_rxchksum( word offset, word len )
{
	word	i;
	ui_t	t;
	dword	ret;

	ret = 0;
	enc_rxseek( offset );
	for( i = 0; len > 1; i++, len -= 2 ){
		t.bytes.hi = enc_readbuf( );
		t.bytes.lo = enc_readbuf( );
		ret += t.data;
		if( ret >= 0x10000 ){	/* I[o[ */
			ret &= 0xffff;
			ret++;		/* L𑫂 */
		}
	}
	if( len == 1 ){			/* oCĝƂ */
		t.bytes.hi = enc_readbuf( );	/* PoCg */
		t.bytes.lo = 0;
		ret += t.data;
		if( ret >= 0x10000 ){	/* I[o[ */
			ret &= 0xffff;
			ret++;		/* L𑫂 */
		}
	}

	return	(word)( ~ret );
}


/**
*	M`FbNTvZ(ERRATAɂADMAgƃ_ȂƂ)
*	in	offset:C[Tlbgt[擪̃ItZbg
*		   len:`FbNTvZ͈͒
*	out	`FbNT
*/
word	enc_txchksum( word offset, word len )
{
	word	i;
	ui_t	t;
	dword	ret;

	ret = 0;
	enc_bankselect( 0 );
	i = offset + TXSTART + PPCB_SIZE;
	enc_writereg16( ERDPT, i );
	for( i = 0; len > 1; i++, len -= 2 ){
		t.bytes.hi = enc_readbuf( );
		t.bytes.lo = enc_readbuf( );
		ret += t.data;
		if( ret >= 0x10000 ){	/* I[o[ */
			ret &= 0xffff;
			ret++;		/* L𑫂 */
		}
	}
	if( len == 1 ){			/* oCĝƂ */
		t.bytes.hi = enc_readbuf( );	/* PoCg */
		t.bytes.lo = 0;
		ret += t.data;
		if( ret >= 0x10000 ){	/* I[o[ */
			ret &= 0xffff;
			ret++;		/* L𑫂 */
		}
	}

	return	(word)( ~ret );
}


/**
*	M`FbNTvZ(ERRATAɂAgȂ)
*	in	offset:C[Tlbgt[擪̃ItZbg
*		   len:`FbNTvZ͈͒
*	out	`FbNT
*/
/**//*word	enc_rxchksum( word offset, word len )*/
/**//*{*/
/**//*	word	i;*/
/**//**/
/**//*	enc_bankselect( 0 );*/
/**//*	i = nowrxpnt + offset + RXSTS_SIZE;*//* Jnʒu */
/**//*	if( i > RXSTOP ){*/		/* ܂ԂĂ */
/**//*		i -= RXSIZE;*/
/**//*	}*/
/**//*	enc_writereg16( EDMAST, i );*/
/**//**/
/**//*	i += len - 1;*/			/* Iʒu */
/**//*	if( i > RXSTOP ){*/		/* ܂ԂĂ */
/**//*		i -= RXSIZE;*/
/**//*	}*/
/**//*	enc_writereg16( EDMAND, i );*/
/**//**/
/**//*	enc_setbit( ECON1, ECON1_DMAST | ECON1_CSUMEN );*/
/**//*	WAIT_DMAEND( );*/		/* I҂ */
/**//**/
/**//*	return	enc_readethreg16( EDMACS );*/
/**//*}*/


/**
*	M`FbNTvZ(ERRATAɂAgȂ)
*	in	offset:C[Tlbgt[擪̃ItZbg
*		   len:`FbNTvZ͈͒
*	out	`FbNT
*/
/**//*word	enc_txchksum( word offset, word len )*/
/**//*{*/
/**//*	word	i;*/
/**//**/
/**//*	enc_bankselect( 0 );*/
/**//**/
/**//*	i = offset + PPCB_SIZE + TXSTART;*/
/**//*	enc_writereg16( EDMAST, i );*/	/* Jnʒu */
/**//**/
/**//*	i += len - 1;*/
/**//*	enc_writereg16( EDMAND, i );*/	/* Iʒu */
/**//**/
/**//*	enc_setbit( ECON1, ECON1_DMAST | ECON1_CSUMEN );*//* vZJn */
/**//*	WAIT_DMAEND( );*/		/* I҂ */
/**//**/
/**//*	return	enc_readethreg16( EDMACS );*/
/**//*}*/


/**
*	 M̈悩瑗M̈փRs[
*	 in	rxoffset:C[Tt[擪ʒũItZbgl
*		txoffset:C[Tt[擪ʒũItZbgl
*		     len:Rs[TCY
*	out	Ȃ
*/
void	enc_packetcopy( word rxoffset, word txoffset, word len )
{
	word	i;

	if( len == 0 ){		/* Rs[f[^Ȃ */
		return;
	}
	else if( len == 1 ){	/* Rs[łȂ̂ŁAʂɏ */
		enc_rxseek( rxoffset );
		enc_txseek( txoffset );
		enc_writebuf( enc_readbuf( ));
		return;
	}
	enc_bankselect( 0 );
	i = nowrxpnt + RXSTS_SIZE + rxoffset;	/* Jnʒu */
	if ( i > RXSTOP ){	/* ܂ԂĂ */
		i -= RXSIZE;
	}
	enc_writereg16( EDMAST, i );

	i += len - 1;		/* Iʒu */
	if( i > RXSTOP ){	/* ܂ԂĂ */
		i -= RXSIZE;
	}
	enc_writereg16( EDMAND, i );

	i = TXSTART + PPCB_SIZE + txoffset;	/* Rs[擪ʒu */
	enc_writereg16( EDMADST, i );

	enc_clrbit( ECON1, ECON1_CSUMEN );	/* `FbNTrbgNA */
	enc_setbit( ECON1, ECON1_DMAST );	/* Rs[Jn */
	WAIT_DMAEND( );		/* I҂ */
}


/**
*	p[_E
*	 in	Ȃ
*	out	Ȃ
*/
/*void	enc_powerdown( void )*/
/*{*/
/*	enc_clrbit( ECON1, ECON1_RXEN );*/	/* M֎~ */
/**/
/**/	/* Mf[^󂯎Î҂ */
/*	while( enc_readethreg( ESTAT ) & ESTAT_RXBUSY );*/
/**/
/**/	/* MWbNZbg҂ */
/*	while( enc_readethreg( ECON1 ) & ECON1_TXRST );*/
/**/
/*	enc_setbit( ECON2, ECON2_PWRSV );*/	/* X[v[h */
/*}*/


/**
*	p[_E畜A
*	 in	Ȃ
*	out	Ȃ
*/
/*void	enc_powerup( void )*/
/*{*/
/*	byte	i;*/
/**/
/*	enc_clrbit( ECON2, ECON2_PWRSV );*/	/* p[_E蕜A */
/*	while( 1 ){*/		/* PHY̏ł̂҂(300us) */
/*		i = enc_readethreg( ESTAT );*/
/*		if((( i & 0x08 ) == 0 ) && (( i & ESTAT_CLKRDY ) == 1 )){*/
/*			break;*/
/*		}*/
/*	}*/
/**/
/*	enc_setbit( ECON1, ECON1_RXEN );*/	/* M */
/*}*/


/**
*	CLKOUTݒ
*	 in	ECOCON̒l
*	out	Ȃ
*/
/*void	enc_setclkout( byte clk )*/
/*{*/
/*	enc_bankselect( 3 );*/
/*	enc_writereg( ECOCON, clk );*/
/*}*/


/**
*	CLKOUT̒lǂ
*	 in	Ȃ
*	out:	ECOCON̒l
*/
/*byte	enc_getclkout( void )*/
/*{*/
/*	enc_bankselect( 3 );*/
/*	return enc_readethreg( ECOCON );*/
/*}*/


/* end of enc28j60.c */
