/**
*	key.c
*	L[͏
*	Copyright (c)Junnichi Tomaru 2008
*/
#include	"avrntp.h"


/**
*	XLR[hL[R[hϊ
*/
static char	scantokey( byte scan )
{
	char	ret;

	if( scan == 0x01 ){
		ret = ENTER_KEY;
	}
	else if( scan == 0x20 ){
		ret = RIGHT_KEY;
	}
	else if( scan == 0x40 ){
		ret = DOWN_KEY;
	}
	else if( scan == 0x80 ){
		ret = UP_KEY;
	}
	else if( scan == 0xc0 ){
		ret = LCDEN_KEY;
	}
	else if( scan == 0xa0 ){
		ret = LCDDI_KEY;
	}
	else{
		ret = 0;
	}

	return	ret;
}


/**
*	L[ZX
*/
char	keysense( void )
{
	char	keyc;
	byte	scan;
	static char	okey;

	_di( );
	scan = keybuf[0];	/* S񕪂̓͂ */
	scan &= keybuf[1];
	scan &= keybuf[2];
	scan &= keybuf[3];
	_ei( );
	if( scan != 0 ){	/* L[͂ */
		keyc = scantokey( scan );	/* R[hϊ */
		if( keyc == okey ){		/* OƓ */
			keyc = 0;	/* ͂ȂƂɂ */
		}
		else{
			okey = keyc;
		}
	}
	else{			/* ͂Ȃ */
		keyc = 0;
		okey = 0;
	}

	return	keyc;
}


/**
*	L[(҂)
*/
static char	keyinput( void )
{
	char	keyc;
	word	wt;

	wt = getcount1ms( );
	while( 1 ){
		wdt_reset( );
		keyc = keysense( );	/* L[ZX */
		if( keyc != 0 ){
			break;
		}
		else if(( getcount1ms( ) - wt ) > 10000U ){
			keyc = KEY_TOUT;
			break;
		}
	}

	return	keyc;
}


/**
*	v镶̈ʒuT
*/
static char	serchchar( char c )
{
	if(( c >= '0' ) && ( c <= '9' )){
		return	c - '0';
	}
	else{
		return	0;
	}
}


/**
*	ݒ
*	 in	x	JnwW
*		y	JnxW
*		setbuf	ݒobt@
*		l	ݒ蒷
*		key	ŌɉꂽL[
*	out	on:ݒ肳ꂽ off:^CAEg
*/
static swbool	setstring( char x, char y, char *setbuf, char l )
{
	char	key, px;
	int	p, ptr;
	swbool	ret;

	p = 0;
	px = x;
	lcdprint( x, y, setbuf );	/* \ */
	*( setbuf + l ) = '\0';
	ptr = serchchar( *setbuf );	/* J[\ʒu̕ */
	_forever{			/* dmsςȂ΍ */
		wdt_reset( );
		if( keysense( ) == 0 ){
			break;
		}
	}
	lcddispcursor( 1 );	/* J[\\ */
	ret = off;
	_forever{
		lcdlocate( px, y );
		lcdputch( ptr + '0' );
		lcdcurleft( );	/* ił܂̂Ŗ߂ */
		key = keyinput( );
		if( key == UP_KEY ){		/* lグ */
			ptr++;
			if( ptr >= 10 ){
				ptr = 0;
			}
			*( setbuf + p ) = ptr + '0';
		}
		else if( key == DOWN_KEY ){	/* l */
			ptr--;
			if( ptr < 0 ){
				ptr = 9;
				if( p != 0 ){
					ptr--;
				}
			}
			*( setbuf + p ) = ptr + '0';
		}
		else if( key == RIGHT_KEY ){	/* J[\Eֈړ */
			p++;
			px++;
			if( p >= l ){
				p = 0;
				px = x;
			}
			ptr = serchchar( *( setbuf + p ) );
		}
		else if( key == ENTER_KEY ){
			ret = on;
			break;
		}
		else if( key == KEY_TOUT ){
			break;
		}
	}
	lcddispcursor( 0 );

	return	ret;
}


/**
*	ԃZbg
*	 in	Ȃ
*	out	Ȃ
*/
void	settime( void )
{
	char	buf[8], dbuf[16];
	time_t	utccnt;
	struct tm	t;

	t = jst_time;
	lcdcls( );
	lcdprintc( 0, 0, PSTR( "SET TIME(JST)" ));
	utoaz( t.tm_year + 1900, buf );		/* l */
	strcpy( dbuf, buf + 1 );
	uctoaz( t.tm_mon + 1, buf );
	strcat( dbuf, buf + 1 );
	uctoaz( t.tm_mday, buf );
	strcat( dbuf, buf + 1 );
	uctoaz( t.tm_hour, buf );
	strcat( dbuf, buf + 1 );
	uctoaz( t.tm_min, buf );
	strcat( dbuf, buf + 1 );
	uctoaz( t.tm_sec, buf );
	strcat( dbuf, buf + 1 );
	if( setstring( 0, 1, dbuf, 14 ) == off ){	/* ҏW */
		return;
	}
	t.tm_sec = _atoi( dbuf + 12 );	/* b */
	dbuf[12] = '\0';
	t.tm_min = _atoi( dbuf + 10 );	/*  */
	dbuf[10] = '\0';
	t.tm_hour = _atoi( dbuf + 8 );	/*  */
	dbuf[8] = '\0';
	t.tm_mday = _atoi( dbuf + 6 );	/*  */
	dbuf[6] = '\0';
	t.tm_mon = _atoi( dbuf + 4 ) - 1;	/*  */
	dbuf[4] = '\0';
	t.tm_year = _atoi( dbuf ) - 1900;	/* N */
	jst2utc( &t, &utc_time );	/* JST->UTC */
	utccnt = mktime( &utc_time );	/* UTC -> sec */
	if( utccnt >= 0 ){
		_di( );
		time = utccnt;
		timer = 0;	/* ^C}Zbg */
		timeen = TIME_ADJUSTED;
		rnstamp = utccnt;
		rntime = 0;
		_ei( );
	}
	else{
		timeen = TIME_UNADJUSTED;
	}
}


/* end of key.c */
