/**
*	nbns.c
*	NBT(NetBIOS over TCP/IP) RFC1001,1002
*	Copyright (c)Junnichi Tomaru 2008
*/
#include	"avrntp.h"

#define		NB	0x20
#define		NBSTAT	0x21

/**
*	NetBIOSO
*	 in	Ȃ
*	out	Ȃ
*/
void	nbns_input( void )
{
	nbns_st	rxnbns;
	nbl_t	d;
	byte	buf[16], k, l, m;
	word	i, j, tid, type, class, sts, len;
	swbool	sw;

	sw = off;
	if( pacinfo.proto_len > 50 ){	/* v͏50INebgŒȂ̂ */
		return;
	}
	enc_rxseek( pacinfo.proto_body );	/* f[^Ɉړ */
	enc_readbuffer((byte *)&rxnbns, 12 );	/* wb_ */
	tid = cnvendian16( rxnbns.trid );
	j = cnvendian16( rxnbns.questions );	/*  */
	for( i = 0; i < j; i++ ){
		l = enc_readbuf( );	/* O(NBNS32Œ肾Aꉞ) */
		if( l > 32 ){
			break;
		}
		for( k = m = 0; m < l; k++ ){	/* ASCIIfR[h */
			d.nbl.hi = ( enc_readbuf( ) - 'A' ) & 0xf;
			m++;
			d.nbl.lo = ( enc_readbuf( ) - 'A' ) & 0xf;
			m++;
			buf[k] = d.data;
		}
		buf[15] = '\0';
		enc_readbuf( );			/* I[R[hǂݔ΂ */
		type = enc_readbuf2( );		/* ^Cv NetBIOS Node Status(0x21) */
		class = enc_readbuf2( );	/* NX Internet(1) */
		if( class == 0x0001 ){
			if(( type == NB ) && ( strcmp( buf, nbns_name ) == 0 )){
				sw = on;	/* ėpl[T[rX̃\[XR[h */
				sts = 0x8500;
				break;
			}
			else if(( type == NBSTAT ) && ( buf[0] == '*' )){
				sw = on;	/* m[hXe[^X\[XR[h */
				sts = 0x8400;
				break;
			}
		}
	}
	if( sw == on ){
		enc_txseek( NBNS_TOP );	
		enc_writebuf2( tid );		/* gUNVhc */
		enc_writebuf2( sts );		/* Status */
		enc_writebuf2( 0x0000 );	/* Question */
		enc_writebuf2( 0x0001 );	/* Answer */
		enc_writebuf2( 0x0000 );	/* ЃZNV */
		enc_writebuf2( 0x0000 );	/* ǉZNV */
		enc_writebuf( 32 );		/*  */
		for( k = 0; k < 16; k++ ){	/* ASCIIGR[h */
			l = buf[k];		/* NetBIOS(̂𖄂ߍ) */
			m = ( l >> 4 ) + 'A';
			enc_writebuf( m );
			m = ( l & 0xf ) + 'A';
			enc_writebuf( m );
		}
		enc_writebuf( 0 );		/* I[ */
		enc_writebuf2( type );		/* Type: NetBIOS Status */
		enc_writebuf2( class );		/* Class: Internet */
		enc_writebuf4( 0 );		/* Time To Live */
		if( type == 0x20 ){
			enc_writebuf2( 6 );		/* f[^ */
			enc_writebuf2( 0x2000 );	/* P-Node,Unique */
			enc_writebuf4( myipaddr );/* NB Address */
			len = 62;
		}
		else{
			enc_writebuf2( 61 );		/* f[^ */
			enc_writebuf( 1 );		/* Number Of Names */
			enc_writebuffer( nbns_name, 15 );	/* NetBIOS() */
			enc_writebuf( 0x00 );		/* Suffix: Workstation */
			enc_writebuf2( 0x2400 );	/* P-Node,Unique,Active */
			enc_writebuffer( mac_address, PHYSICALADDR_SIZE );/* Node Address */
			enc_fillwrite( 0x00, 36 );	/* ̑(S0) */
			len = 117;
		}
		udp_output( len );
	}
}


/* end of nbns.c */
