/**
*	ntp.c
*	Network Time Protocol: CvgR RFC1305,2030
*	Copyright (c)Junnichi Tomaru 2008
*/
#include	"avrntp.h"

#define	TIME_CONST	0x83aa7e80
/* 70N̕b(25567 * 24 * 60 * 60b = 2208988800 = 0x83aa7e80) */


/**
*	_ȉ^C}l^CX^vɂ
*	 in	_ȉ^C}l
*	out	^CX^v
*/
static dword	timer2stamp( dword timer )
{
	union{
		uint64_t	data;	/* vZp */
		struct{
			dword	lo;
			dword	hi;
		} dwords;
	} tmp;
	dword	ret;

	tmp.dwords.hi = timer;	/* time * 4294967296 */
	tmp.dwords.lo = 0L;
	ret = ( dword )( tmp.data / 1000ULL );	/* ( tmp / 1000 ) */

	return	ret;
}


/**
*	mso
*	 in	Ȃ
*	out	Ȃ
*/
void	ntp_input( void )
{
	byte	flg;
	time_t	urn, urx, utx;
	dword	drn, drx, dtx;
	ntp_st	rxntp;

	flg = ( timeen == TIME_ADJUSTED )? 1: 0;
	enc_rxseek( pacinfo.proto_body );	/* f[^Ɉړ */
	enc_readbuffer((byte *)&rxntp, sizeof( rxntp ));	/* NTPǂݍ */
	rxntp.livnmd &= 0x38;	/* o[Wioo */
	if( flg ){
		rxntp.stratum = 1;	/* dgvQƂꍇ,K1łׂ */
		/* Qƃ^CX^v */
		urn = rnstamp + TIME_CONST;	/* UTCNTPԕϊ */
		drn = timer2stamp( rntime );	/* _ȉ */
		/* M^CX^v */
		urx = rxstamp + TIME_CONST;	/* UTCNTPԕϊ */
		drx = timer2stamp( rxtime );	/* _ȉ */
	}
	else{
		rxntp.livnmd |= 0xc0;	/* ԂĂȂƂLI=3 */
		rxntp.stratum = 0;
		/* QƁEMEM^CX^v=0 */
		urn = urx = utx = 0;
		drn = drx = dtx = 0;
	}
	/* Mobt@ւ̃Zbg */
	enc_txseek( UDP_DATA );
	enc_writebuf( rxntp.livnmd | 0x4 );/* LI,VN,MODE(T[o) */
	enc_writebuf( rxntp.stratum );	/* K */
	enc_writebuf( rxntp.interval );	/* |[OԊu(IWiRs[) */
	enc_writebuf( 0xf6 );		/* x(-10(0.9765625ms),1msƂ̃JEg) */
	enc_writebuf4( 0L );		/* [gx(K1) */
	enc_writebuf4( 0L );		/* [gU(K1) */
	enc_writebuf4( 0x50505300 );	/* QƎʎq("PPS") */
	enc_writebuf4( urn );		/* Qƃ^CX^v */
	enc_writebuf4( drn );		/* _ȉ */
	if( flg ){
		enc_writebuf( rxntp.txts.b1 );	/* Jn^CX^v */
		enc_writebuf( rxntp.txts.b2 );	/* M^CX^vRs[ */
		enc_writebuf( rxntp.txts.b3 );
		enc_writebuf( rxntp.txts.b4 );
		enc_writebuf( rxntp.txts.b5 );
		enc_writebuf( rxntp.txts.b6 );
		enc_writebuf( rxntp.txts.b7 );
		enc_writebuf( rxntp.txts.b8 );
	}
	else{
		enc_writebuf4( 0L );
		enc_writebuf4( 0L );
	}
	enc_writebuf4( urx );	/* M^CX^v */
	enc_writebuf4( drx );
	if( flg ){		/* M^CX^v𐳊mɂ邽߁Aŏ */
		_di( );
		utx = time + TIME_CONST;	/* UTCNTPԕϊ */
		dtx = timer2stamp( timer );	/* _ȉ */
		_ei( );
	}
	enc_writebuf4( utx );	/* M^CX^v */
	enc_writebuf4( dtx );
	udp_output( 48U );
}


/* end of ntp.c */
