/**
*	ut.c
*	Tu[`W
*	Copyright (c)Junnichi Tomaru 2006
*/
#include	<avr/pgmspace.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<string.h>
#include	"ut.h"

const char	hexnum[] = "0123456789ABCDEF";


/**
*	l16i(unsigned char)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*uctoahz( byte num, char *buf )
{
	nbl_t	uni;

	uni.data = num;
	*( buf + 0 ) = hexnum[uni.nbl.hi];
	*( buf + 1 ) = hexnum[uni.nbl.lo];
	*( buf + 2 ) = '\0';

	return	buf;
}


/**
*	l10i(unsigned char,[TvXȂ)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*uctoaz( byte num, char *buf )
{
	byte	n;
	char	i, *p;

	p = buf;
	for( n = 100; n > 1; n /= 10, p++ ){
		i = num / n;
		num %= n;
		*p = ( char )( i + '0' );
	}
	*p = num + '0';
	*( p + 1 ) = '\0';

	return	buf;
}


/**
*	AXL[(unsigned short,[TvXȂ)
*	 in	num:f[^
*		buf:i[敶
*	out	obt@|C^
*/
char	*utoaz( word num, char *buf )
{
	word	n;
	int	i;
	char	*p;

	p = buf;
	for( n = 10000U; n > 1U; n /= 10U, p++ ){
		i = num / n;
		num %= n;
		*p = ( char )( i + '0' );
	}
	*p = num + '0';
	*( p + 1 ) = '\0';

	return	buf;
}


/**
*	10i𐔒l(16bit)
*	  l̂ݑΉ(}CiX͕s)
*	 in	
*	out	l
*/
int	_atoi( char *buf )
{
	int	ret;

	ret = 0;
	while(( *buf >= '0' ) && ( *buf <= '9' )){
		ret *= 10;	/* ̌ֈړ */
		ret += *buf - '0';
		buf++;
	}

	return	ret;
}


/**
*	GfBAւ(16bit)
*	 in	ւf[^
*	out	ւ̃f[^
*/
word	cnvendian16( word data )
{
	ui_t	ret, tmp;

	tmp.data = data;
	ret.bytes.lo = tmp.bytes.hi;
	ret.bytes.hi = tmp.bytes.lo;

	return	ret.data;
}


/**
*	GfBAւ(32bit)
*	 in	ւf[^
*	out	ւ̃f[^
*/
dword	cnvendian32( dword data )
{
	ul_t	ret, w;

	w.data = data;
	ret.bytes.ll = w.bytes.hh;
	ret.bytes.lh = w.bytes.hl;
	ret.bytes.hl = w.bytes.lh;
	ret.bytes.hh = w.bytes.ll;

	return	ret.data;
}


/**
*	hoAhX𕶎ɂ(RŒ)
*	 in	ipadr:hoAhX
*		  buf:i[敶
*	out	obt@|C^
*/
char	*long2ipstr( dword ipadr, char *buf )
{
	ul_t	tmp;

	tmp.data = ipadr;
	uctoaz( tmp.bytes.hh, buf );
	*( buf + 3 ) = '.';
	uctoaz( tmp.bytes.hl, buf + 4 );
	*( buf + 7 ) = '.';
	uctoaz( tmp.bytes.lh, buf + 8 );
	*( buf + 11 ) = '.';
	uctoaz( tmp.bytes.ll, buf + 12 );

	return	buf;
}


/**
*	{ԂUTCɕϊ
*	NAANSIɏĂ邱
*	 in	jst	{
*		utc	UTC
*	out	Ȃ
*/
void	jst2utc( struct tm *jst, struct tm *utc )
{
	time_t	t;
	struct tm	*tmp;

	t = mktime( jst );
	t -= 32400L;	/* 9ԕ */
	tmp = gmtime( &t );
	if( tmp != NULL ){
		*utc = *tmp;
	}
}


/**
*	UTC{Ԃɕϊ
*	NAANSIɏĂ邱
*	 in	utc	UTC
*		jst	{
*	out	Ȃ
*/
void	utc2jst( struct tm *utc, struct tm *jst )
{
	time_t	t;
	struct tm	*tmp;

	t = mktime( utc );
	t += 32400L;	/* 9ԕ */
	tmp = gmtime( &t );
	if( tmp != NULL ){
		*jst = *tmp;
	}
}


/* end of ut.c */
